// Written by TeTeT for Unsung
// Alpha Strike on Doung island

#define SPEEDTAXI 2

ttt_refueled = [];
ttt_markers = [];

ttt_setAlt = {
	params ["_veh", "_alt"];
	_veh flyInHeight 100;
	_veh flyInHeightASL [_alt, _alt, _alt];
	_veh;
};

ttt_setCycle = {
	params ["_veh", "_wp1", "_wp2"];
	private _wp = (group leader _veh) addWaypoint [_wp1, 100];
	_wp setWaypointType "MOVE";
	_wp setWaypointSpeed "LIMITED";
	_wp = (group leader _veh) addWaypoint [_wp2, 100];
	_wp setWaypointType "CYCLE";
	_wp setWaypointSpeed "LIMITED";
};

ttt_driveTo = {
	params ["_veh", "_wp"];
	while {_veh distance2D _wp > 5} do {
	    private _v = [getPosASL _veh, _wp] call BIS_fnc_vectorFromXToY;
	    _veh setVelocity [
		  (_v select 0) * SPEEDTAXI,
		  (_v select 1) * SPEEDTAXI,
		  0
	    ];
	    sleep 0.05;
	};
	_veh;
};

ttt_turnTo = {
	params ["_veh", "_to"];
	private _dir = getDir _veh;
	private _toward = _veh getDir _to;
	private _turn = 0.1;
	if (_dir - _toward > 0) then {
		_turn = -0.1;
	};
	while {floor (getDir _veh) != floor _toward} do {
		// systemChat format ["Dir: %1, Toward: %2", getDir _veh, _toward];
		_veh setDir (getDir _veh + _turn);
		sleep 0.02;
	};
	_veh setDir (_veh getDir _to);	
	_veh;
};

ttt_taxiTo = {
	params ["_veh", "_wps"];
	{
		[_veh, _x] call ttt_turnTo; 
		[_veh, _x] call ttt_driveTo;
	} forEach _wps;
	_veh;
};

ttt_fuelWhenAttached = {
	params ["_veh"]	;

	waitUntil {sleep 1; !(isNull (attachedTo _veh));};
	_veh setFuel 1;
};

[] spawn {
	private _carrier = Nimitz;
	private _sar = SAR;
	private _EAW = [ [RedCrown, 3] ];
	private _tankers = [ [Tanker1, 3], [Tanker2, 3] ];\
	private _sead = [ [ SEAD1, 2], [ SEAD2, 1] ];
	private _bombersFore = [ [B1, 1], [B2, 2], [B3, 1], [B4, 2] ];
	private _bombersAft = [ [B5, 3], [B6, 3],
						 [B7, 3], [B8, 3] ];

	private _escorts = [ [CAP2, 1], [CAP1, 2] ];

	private _nimspots = _carrier getVariable "nimspots";
	private _posC1 = _nimspots modeltoworld (_nimspots selectionposition "C1");
	private _posC2 = _nimspots modeltoworld (_nimspots selectionposition "C2");	
	private _posC3 = _nimspots modeltoworld (_nimspots selectionposition "C3");
	private _posE2 = _nimspots modeltoworld (_nimspots selectionposition "E1");
	private _posE2 = _nimspots modeltoworld (_nimspots selectionposition "E2");
	private _posE3 = _nimspots modeltoworld (_nimspots selectionposition "E3");
	private _posE4 = _nimspots modeltoworld (_nimspots selectionposition "E4");
	private _posWires = _nimspots modeltoworld (_nimspots selectionposition "WireCenter");

	private _sarOffset1 = _carrier getPos [400, (getDir _carrier) - 45];
	private _sarOffset2 = _carrier getPos [400, (getDir _carrier) - 135];

	[_sar, _sarOffset1, _sarOffset2] call ttt_setCycle;
	ttt_refueled pushBack _sar;
	ttt_markers pushBack [_sar, "SAR"];
	ttt_refueled pushBack E1;
	ttt_markers pushBack [E1, "CAP-1"];
	ttt_refueled pushBack E2;
	ttt_markers pushBack [E2, "CAP-2"];

	private _eawOffset1 = _carrier getPos [1000, (getDir _carrier) - 90];
	private _eawOffset2 = _carrier getPos [11000, (getDir _carrier) - 90];
	{
		[_x select 0, "lower"] call uns_e2_fnc_wings;
		[_carrier, _x select 0, _x select 1] call ttt_fnc_planeStart;
		[_x select 0, 3000] call ttt_setAlt;
		[_x select 0, _eawOffset1, _eawOffset2] call ttt_setCycle;
		ttt_refueled pushBack (_x select 0);
		ttt_markers pushBack [_x select 0, "Red Crown"];
	} forEach _EAW;


	private _tankerOffset1 = _carrier getPos [1000, (getDir _carrier) - 90];
	private _tankerOffset2 = _carrier getPos [21000, (getDir _carrier) - 90];
	{
		(_x select 0) engineOn true;
		[_x select 0, [_posWires, _posC3]] call ttt_taxiTo;
		[_x select 0, "lower"] call uns_a3b_fnc_wings;
		[_carrier, _x select 0, _x select 1] call ttt_fnc_planeStart;
		[_x select 0, 2000] call ttt_setAlt;
		[_x select 0, _tankerOffset1, _tankerOffset2] call ttt_setCycle;
		ttt_refueled pushBack (_x select 0);
		ttt_markers pushBack [_x select 0, "Tanker-" + str(_forEachIndex + 1)];
	} forEach _tankers;

	private _strikeOffset1 = _carrier getPos [1000, (getDir _carrier) + 90];
	private _strikeOffset2 = _carrier getPos [5000, (getDir _carrier) + 90];
	{
		[_x select 0, "lower"] call uns_a7_fnc_wings;
		[_carrier, _x select 0, _x select 1, _forEachIndex, _strikeOffset1, _strikeOffset2] spawn {
			params ["_carrier", "_veh", "_dest", "_idx", "_so1", "_so2"];
			[_carrier, _veh, _dest] call ttt_fnc_planeStart;
			[_veh, 1500] call ttt_setAlt;
			[_veh, _so1, _so2] call ttt_setCycle;
			ttt_refueled pushBack _veh;
			ttt_markers pushBack [_veh, "SEAD-" + str(_idx + 1)];
		};
		sleep 10;
	} forEach _sead;
	[_bombersAft, _carrier, _strikeOffset1, _strikeOffset2, _posC3] spawn {
		params ["_bombers", "_carrier", "_so1", "_so2", "_posC3"];
		{
			(_x select 0) engineOn true;
			private _firstPos = _posC3 getPos [-15, getDir _carrier];
			[_x select 0, [_firstPos, _posC3]]  call ttt_taxiTo;
			[_carrier, _x select 0, _x select 1, _forEachIndex, _so1, _so2] spawn {
				params ["_carrier", "_veh", "_dest", "_idx", "_so1", "_so2"];
				[_veh, "lower"] call uns_a6_fnc_wings;
				[_carrier, _veh, _dest] call ttt_fnc_planeStart;
				[_veh, 2500] call ttt_setAlt;
				[_veh, _so1, _so2] call ttt_setCycle;
				ttt_refueled pushBack _veh;
				ttt_markers pushBack [_veh, "Strike-" + str(_idx + 10)];
			};
			sleep 40;
		} forEach _bombers;
	};
	sleep 20;
	{
		(_x select 0) engineOn true;
		if ((_x select 1) isEqualTo 1) then {
			[_x select 0, [_posC1]] call ttt_taxiTo;
		};
		if ((_x select 1) isEqualTo 2) then {
			[_x select 0, [_posC2]] call ttt_taxiTo;
		};
		[_carrier, _x select 0, _x select 1, _forEachIndex, _strikeOffset1, _strikeOffset2] spawn {
			params ["_carrier", "_veh", "_dest", "_idx", "_so1", "_so2"];
			[_veh, "lower"] call uns_a6_fnc_wings;
			[_carrier, _veh, _dest] call ttt_fnc_planeStart;
			[_veh, 3000] call ttt_setAlt;
			[_veh, _so1, _so2] call ttt_setCycle;
			ttt_refueled pushBack _veh;
			ttt_markers pushBack [_veh, "Strike-" + str(_idx + 1)];
		};
		sleep 10;
	} forEach _bombersFore;

	{
		(_x select 0) engineOn true;
		if ((_x select 1) isEqualTo 1) then {
			[_x select 0, [_posC1 getPos [-15, getDir _carrier], _posC1]] call ttt_taxiTo;
		};
		if ((_x select 1) isEqualTo 2) then {
			[_x select 0, [_posC2 getPos [-15, getDir _carrier], _posC2]] call ttt_taxiTo;
		};
		[_carrier, _x select 0, _x select 1, _forEachIndex, _strikeOffset1, _strikeOffset2] spawn {
			params ["_carrier", "_veh", "_dest", "_idx", "_so1", "_so2"];
			[_veh, "lower"] call uns_f4e_c_fnc_wings;
			[_carrier, _veh, _dest] call ttt_fnc_planeStart;
			[_veh, 3500] call ttt_setAlt;
			[_veh, _so1, _so2] call ttt_setCycle;
			ttt_refueled pushBack _veh;
			ttt_markers pushBack [_veh, "Escort-" + str(_idx + 1)];
		};
	} forEach _escorts;

};

[] spawn {
	while {alive player} do {
		sleep 1800;
		{
			_x setFuel 1;
		} forEach ttt_refueled;
	};
};

[] spawn {
	while {alive player} do {
		sleep 1;
		// systemChat str ttt_markers;
		{
			private _veh = _x select 0;
			private _txt = (_x select 1) + "-" + str(floor(getPosASL _veh select 2));
			deleteMarkerLocal str(_forEachIndex);
			if (alive _veh) then {
				private _marker = createMarkerLocal [str(_forEachIndex), getPos _veh];
				_marker setMarkerTypeLocal "b_air";
				_marker setMarkerTextLocal _txt;
			}

		} forEach ttt_markers;
	};
};